Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_split.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_split.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_split.cpp	(revision 1520)
@@ -31,4 +31,25 @@
     inout_vector->swap(out_vec);
   }
+  
+  void vec_simplify(std::vector<int> *in_vector, std::vector<int> *out_vector)
+  {
+    int found=false;
+    for(std::vector<int>::iterator it_in = in_vector->begin() ; it_in != in_vector->end(); ++it_in)
+    {
+      for(std::vector<int>::iterator it = out_vector->begin() ; it != out_vector->end(); ++it)
+      {
+        if(*it_in == *it)
+        {
+          found=true;
+          break;
+        }
+        else found=false;
+      }
+      if(found == false)
+      {
+        out_vector->push_back(*it_in);
+      }
+    }
+  }
 
 
@@ -39,10 +60,10 @@
     int ep_size, num_ep, mpi_size;
 
-    ep_rank = comm.ep_comm_ptr->size_rank_info[0].first;
-    ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
-    mpi_rank = comm.ep_comm_ptr->size_rank_info[2].first;
-    ep_size = comm.ep_comm_ptr->size_rank_info[0].second;
-    num_ep = comm.ep_comm_ptr->size_rank_info[1].second;
-    mpi_size = comm.ep_comm_ptr->size_rank_info[2].second;
+    ep_rank = comm->ep_comm_ptr->size_rank_info[0].first;
+    ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
+    mpi_rank = comm->ep_comm_ptr->size_rank_info[2].first;
+    ep_size = comm->ep_comm_ptr->size_rank_info[0].second;
+    num_ep = comm->ep_comm_ptr->size_rank_info[1].second;
+    mpi_size = comm->ep_comm_ptr->size_rank_info[2].second;
 
     int num_color = 0;
@@ -52,22 +73,28 @@
     vector<int> matched_number;
     vector<int> matched_number_loc;
-
-
+    
     vector<int> all_color(ep_size);
     vector<int> all_color_loc(num_ep);
 
-    MPI_Gather_local(&color, 1, MPI_INT, all_color_loc.data(), 0, comm);
-    MPI_Bcast_local(all_color_loc.data(), num_ep, MPI_INT, 0, comm);
-
-
     MPI_Allgather(&color, 1, MPI_INT, all_color.data(), 1, MPI_INT, comm);
+    MPI_Allgather_local(&color, 1, MPI_INT, all_color_loc.data(), comm);
 
     list<int> color_list(all_color.begin(), all_color.end());
     list<int> color_list_loc(all_color_loc.begin(), all_color_loc.end());
 
-    vec_simplify(&all_color);
-
-    matched_number.resize(all_color.size(), 0);
-    matched_number_loc.resize(all_color.size(), 0);
+    vector<int> all_color_simplified;
+    vec_simplify(&all_color, &all_color_simplified);
+    int number_of_color;
+    for(int i=0; i<all_color_simplified.size(); i++)
+    {
+      if(color == all_color_simplified[i])
+      {
+        number_of_color = i;
+        break;
+      }
+    }
+
+    matched_number.resize(all_color_simplified.size(), 0);
+    matched_number_loc.resize(all_color_simplified.size(), 0);
 
 
@@ -93,13 +120,24 @@
       num_color++;
     }
-
-
+        
+
+    vector<int> all_key(ep_size);
+    vector<int> all_key_loc(num_ep);
+    
+    vector<int> colored_key[num_color];
     vector<int> colored_key_loc[num_color];
-    vector<int> key_loc(num_ep);
-
-    MPI_Gather_local(&key, 1, MPI_INT, key_loc.data(), 0, comm);
-    MPI_Bcast_local(key_loc.data(), num_ep, MPI_INT, 0, comm);
-    
-    std::sort(key_loc.begin(), key_loc.end());
+    
+
+    MPI_Allgather(&key, 1, MPI_INT, all_key.data(),1, MPI_INT, comm);
+    MPI_Allgather_local(&key, 1, MPI_INT, all_key_loc.data(), comm);
+    
+    vector<int> all_ep_rank(ep_size);
+    vector<int> all_ep_rank_loc(num_ep);
+    
+    vector<int> colored_ep_rank[num_color];
+    vector<int> colored_ep_rank_loc[num_color];
+    
+    MPI_Allgather(&ep_rank, 1, MPI_INT, all_ep_rank.data(),1, MPI_INT, comm);
+    MPI_Allgather_local(&ep_rank, 1, MPI_INT, all_ep_rank_loc.data(), comm);
 
     for(int i=0; i<num_ep; i++)
@@ -107,31 +145,90 @@
       for(int j = 0; j<num_color; j++)
       {
-        if(all_color_loc[i] == all_color[j])
-        {
-          colored_key_loc[j].push_back(key_loc[i]);
-        }
-      }
-    }
-
+        if(all_color_loc[i] == all_color_simplified[j])
+        {
+          colored_key_loc[j].push_back(all_key_loc[i]);
+          colored_ep_rank_loc[j].push_back(all_ep_rank_loc[i]);
+        }
+      }
+    }
+    
+    for(int i=0; i<ep_size; i++)
+    {
+      for(int j = 0; j<num_color; j++)
+      {
+        if(all_color[i] == all_color_simplified[j])
+        {
+          colored_key[j].push_back(all_key[i]);
+          colored_ep_rank[j].push_back(all_ep_rank[i]);
+        }
+      }
+    }
+    
+    int my_offset=0;
+    for(int i=0; i<colored_key[number_of_color].size(); i++)
+    {
+      if(key == colored_key[number_of_color][i])
+      {
+        if(ep_rank != colored_ep_rank[number_of_color][i])
+        {
+          my_offset++;
+        }
+        else
+          break;
+      }
+    }
+    
+    int my_offset_loc=0;
+    for(int i=0; i<colored_key_loc[number_of_color].size(); i++)
+    {
+      if(key == colored_key_loc[number_of_color][i])
+      {
+        if(ep_rank != colored_ep_rank_loc[number_of_color][i])
+        {
+          my_offset_loc++;
+        }
+        else
+          break;
+      }
+    }
+    
+    
+    
+    for(int i=0; i<num_color; i++)
+    {
+      std::sort(colored_key[i].begin(), colored_key[i].end());
+      std::sort(colored_key_loc[i].begin(), colored_key_loc[i].end());
+    }
+
+    int new_ep_rank;
+    
+    for(int i=0; i<colored_key[number_of_color].size(); i++)
+    {
+      if(key == colored_key[number_of_color][i])
+      {
+        new_ep_rank = i+my_offset;
+        break;
+      }
+    }
+    
     int new_ep_rank_loc;
-
-    for(int i=0; i<num_color; i++)
-    {
-      if(colored_key_loc[i].size()>1)
-      {
-        std::sort(colored_key_loc[i].begin(), colored_key_loc[i].end());
-      }
-      if(color == all_color[i])
-      {
-        for(int j=0; j<colored_key_loc[i].size(); j++)
-        {
-          if(key == colored_key_loc[i][j])
-          {
-            new_ep_rank_loc = j;
-            break;
-          }
-        }
-      }
-    }
+    
+    for(int i=0; i<colored_key_loc[number_of_color].size(); i++)
+    {
+      if(key == colored_key_loc[number_of_color][i])
+      {
+        new_ep_rank_loc = i+my_offset_loc;
+        break;
+      }
+    }
+
+#ifdef _showinfo
+    printf("ep_rank = %d, color = %d, key = %d, new_ep_rank = %d, new_ep_rank_loc = %d\n", ep_rank, color, key, new_ep_rank, new_ep_rank_loc);
+#endif
+
+    MPI_Barrier(comm);
+    MPI_Barrier(comm);
+    MPI_Barrier(comm);
+    
 
     ::MPI_Comm **split_mpi_comm;
@@ -147,12 +244,14 @@
         if(matched_number_loc[j] == 0) master_color = MPI_UNDEFINED;
 
-        ::MPI_Comm_split(to_mpi_comm(comm.mpi_comm), master_color, mpi_rank, split_mpi_comm[j]);
-        
-        comm.ep_comm_ptr->comm_list->mpi_bridge = split_mpi_comm[j];
-      }
+        ::MPI_Comm_split(to_mpi_comm(comm->mpi_comm), master_color, mpi_rank, split_mpi_comm[j]);
+        
+        comm->ep_comm_ptr->comm_list[0]->mpi_bridge = split_mpi_comm[j];
+      }
+      
       MPI_Barrier_local(comm);
+      
       int num_new_ep = 0;
 
-      if(new_ep_rank_loc == 0 && color == all_color[j])
+      if(new_ep_rank_loc == 0 && color == all_color_simplified[j])
       {
         num_new_ep = matched_number_loc[j];
@@ -160,21 +259,86 @@
         MPI_Comm *ep_comm;
 
-        MPI_Comm_create_endpoints(comm.ep_comm_ptr->comm_list->mpi_bridge, num_new_ep, info, ep_comm);
-
-
-        comm.ep_comm_ptr->comm_list->mem_bridge = ep_comm;
-      }
+        MPI_Comm_create_endpoints(comm->ep_comm_ptr->comm_list[0]->mpi_bridge, num_new_ep, info, ep_comm);
+
+        comm->ep_comm_ptr->comm_list[0]->mem_bridge = ep_comm;
+        
+        (*ep_comm)->ep_rank_map->clear();
+        
+        memcheck("in MPI_Split ep_rank="<< ep_rank <<" : *ep_comm = "<< *ep_comm);
+      }
+      
       MPI_Barrier_local(comm);
-      if(color == all_color[j])
-      {
-        *newcomm = comm.ep_comm_ptr->comm_list->mem_bridge[new_ep_rank_loc];
-
-        (*newcomm).ep_comm_ptr->comm_label = color;
-      }
-    }
-
-
-
-
+      
+      if(color == all_color_simplified[j])
+      {
+        *newcomm = comm->ep_comm_ptr->comm_list[0]->mem_bridge[new_ep_rank_loc];
+        memcheck("in MPI_Split ep_rank="<< ep_rank <<" : *newcomm = "<< *newcomm);
+
+        (*newcomm)->ep_comm_ptr->comm_label = color;
+        
+        (*newcomm)->ep_comm_ptr->size_rank_info[0].first = new_ep_rank;
+        (*newcomm)->ep_comm_ptr->size_rank_info[1].first = new_ep_rank_loc;
+        
+        int my_triple[3];
+        vector<int> my_triple_vector;
+        vector<int> my_triple_vector_recv;
+        my_triple[0] = new_ep_rank;
+        my_triple[1] = new_ep_rank_loc;
+        my_triple[2] = (*newcomm)->ep_comm_ptr->size_rank_info[2].first; // new_mpi_rank
+        
+        int new_ep_size = (*newcomm)->ep_comm_ptr->size_rank_info[0].second;
+        int new_num_ep  = (*newcomm)->ep_comm_ptr->size_rank_info[1].second;
+        
+        int new_mpi_size = (*newcomm)->ep_comm_ptr->size_rank_info[2].second;
+        
+        if(new_ep_rank_loc == 0) my_triple_vector.resize(3*new_ep_size);
+        if(new_ep_rank_loc == 0) my_triple_vector_recv.resize(3*new_ep_size);
+        
+        MPI_Gather_local(my_triple, 3, MPI_INT, my_triple_vector.data(), 0, *newcomm);
+        
+        if(new_ep_rank_loc == 0)
+        {
+          int *recvcounts = new int[new_mpi_size];
+          int *displs = new int[new_mpi_size];
+          int new_num_epx3 = new_num_ep * 3;
+          ::MPI_Allgather(&new_num_epx3, 1, to_mpi_type(MPI_INT), recvcounts, 1, to_mpi_type(MPI_INT), to_mpi_comm((*newcomm)->mpi_comm));
+          displs[0]=0;
+          for(int i=1; i<new_mpi_size; i++)
+            displs[i] = displs[i-1] + recvcounts[i-1];
+             
+          ::MPI_Allgatherv(my_triple_vector.data(), 3*new_num_ep, to_mpi_type(MPI_INT), my_triple_vector_recv.data(), recvcounts, displs, to_mpi_type(MPI_INT), to_mpi_comm((*newcomm)->mpi_comm));
+          
+          for(int i=0; i<new_ep_size; i++)
+          {
+            (*newcomm)->ep_comm_ptr->comm_list[0]->ep_rank_map->insert(std::pair< int, std::pair<int,int> >(my_triple_vector_recv[3*i], my_triple_vector_recv[3*i+1], my_triple_vector_recv[3*i+2]));
+          }
+          
+          (*newcomm)->ep_rank_map = (*newcomm)->ep_comm_ptr->comm_list[0]->ep_rank_map;
+          
+          delete recvcounts;
+          delete displs;
+        } 
+      }
+    }
+
+#ifdef _Memory_check   
+    for(int i=0; i<ep_size; i++)
+    {
+      MPI_Barrier(comm);
+      MPI_Barrier(comm);
+      if(ep_rank==i) 
+      {
+        printf("ep_rank_map for endpoint %d = \n", ep_rank);
+        for(std::map<int, std::pair<int, int> > :: iterator it = (*newcomm)->ep_rank_map->begin(); it != (*newcomm)->ep_rank_map->end(); it++)
+        {
+          printf("\t\t\t %d %d %d\n", it->first, it->second.first, it->second.second);
+        }
+        printf("\n");
+      }
+      MPI_Barrier(comm);
+      MPI_Barrier(comm);
+    }   
+#endif
+    
     return 0;
   }
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_test.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_test.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_test.cpp	(revision 1520)
@@ -22,15 +22,18 @@
     
 
-    if(request->type == 1)      // isend
+    if((*request)->type == 1)      // isend
     {
       ::MPI_Status mpi_status;
-      ::MPI_Test(static_cast< ::MPI_Request*>(request->mpi_request), flag, &mpi_status);
+      ::MPI_Test(static_cast< ::MPI_Request*>((*request)->mpi_request), flag, &mpi_status);
       
       if(*flag) 
       {
         status->mpi_status = new ::MPI_Status(mpi_status);
-        status->ep_src = request->ep_src;
-        status->ep_tag = request->ep_tag;
-        status->ep_datatype = request->ep_datatype;
+        status->ep_src = (*request)->ep_src;
+        status->ep_tag = (*request)->ep_tag;
+        status->ep_datatype = (*request)->ep_datatype;
+        (*request)->state = 2;
+        delete (*request)->mpi_request;
+        delete *request;
       }
 
@@ -38,5 +41,5 @@
     }
 
-    if(request->type == 2)   // irecv message not probed
+    if((*request)->type == 2)   // irecv message not probed
     {
       Request_Check();
@@ -46,9 +49,13 @@
     }
 
-    if(request->type == 3)  // imrecv
+    if((*request)->type == 3)  // imrecv
     {
+      if((*request)->state == 2)
+      {
+        return *flag = true;
+      }
       ::MPI_Status mpi_status;
       
-      ::MPI_Test(static_cast< ::MPI_Request*>(request->mpi_request), flag, &mpi_status);
+      ::MPI_Test(static_cast< ::MPI_Request*>((*request)->mpi_request), flag, &mpi_status);
       
       
@@ -56,7 +63,12 @@
       {
         status->mpi_status = new ::MPI_Status(mpi_status);
-        status->ep_src = request->ep_src;
-        status->ep_tag = request->ep_tag;
-        status->ep_datatype = request->ep_datatype;
+        status->ep_src = (*request)->ep_src;
+        status->ep_tag = (*request)->ep_tag;
+        status->ep_datatype = (*request)->ep_datatype;
+        
+        (*request)->state = 2;
+        
+        delete (*request)->mpi_request;
+        delete *request;
         //int count;
         //MPI_Get_count(status, request->ep_datatype, &count);
@@ -64,5 +76,5 @@
       }  
 
-      return 0;
+      return Request_Check();
     }
 
@@ -73,13 +85,38 @@
   {
     Debug("MPI_Testall with EP");
-    *flag = true;
-    int i=0;
-    while(*flag && i<count )
+
+    ::MPI_Request* mpi_request = new ::MPI_Request[count];
+    ::MPI_Status* mpi_status = new ::MPI_Status[count];
+
+
+    for(int i=0; i<count; i++)
     {
-      MPI_Test(&array_of_requests[i], flag, &array_of_statuses[i]);
-      i++;
+      mpi_request[i] = *static_cast< ::MPI_Request*>(array_of_requests[i]->mpi_request);
     }
+
+    ::MPI_Testall(count, mpi_request, flag, mpi_status);
+
+    if(*flag)
+    {
+      for(int i=0; i<count; i++)
+      {
+        array_of_statuses[i].mpi_status = &mpi_status[i];
+        array_of_statuses[i].ep_src = array_of_requests[i]->ep_src;
+        array_of_statuses[i].ep_tag = array_of_requests[i]->ep_tag;
+        array_of_statuses[i].ep_datatype = array_of_requests[i]->ep_datatype;
+        
+        array_of_requests[i]->state = 2;
+      
+        memcheck("delete "<< array_of_requests[i]->mpi_request <<" : in ep_lib::MPI_Waitall, array_of_requests["<<i<<"]->mpi_request");
+        delete array_of_requests[i]->mpi_request;
+        delete array_of_requests[i]; 
+      }
+      
+    }
+
+    return Request_Check();
   }
 
 
 }
+
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.cpp	(revision 1520)
@@ -11,65 +11,27 @@
 namespace ep_lib
 { 
-  
-  ep_intercomm::ep_intercomm()
+  ep_comm::ep_comm(void* comm)
   {
-    intercomm_rank_map = NULL;
-    local_rank_map = NULL;
-    remote_rank_map = NULL;
-    mpi_inter_comm = new ::MPI_Comm;
+    is_ep = false;
+    is_intercomm = false;
+    mpi_comm = static_cast< ::MPI_Comm*>(comm);
   }
 
-  bool ep_intercomm::operator == (ep_intercomm right)
+  ep_info::ep_info(void* info)
   {
-    bool a = intercomm_rank_map == right.intercomm_rank_map;
-    bool b = local_rank_map == right.local_rank_map;
-    bool c = remote_rank_map == right.remote_rank_map;
-    bool d = *(static_cast< ::MPI_Comm*>(mpi_inter_comm)) == *(static_cast< ::MPI_Comm*>(right.mpi_inter_comm));
-    bool e = size_rank_info == right.size_rank_info;
-    bool f = intercomm_tag == right.intercomm_tag;
-    return a&&b&&c&&d&&e&&f;
+    mpi_info = static_cast< ::MPI_Info*>(info);
   }
 
-  bool ep_intercomm::operator != (ep_intercomm right)
+  ep_request::ep_request(void* request)
   {
-    bool a = intercomm_rank_map != right.intercomm_rank_map;
-    bool b = local_rank_map != right.local_rank_map;
-    bool c = remote_rank_map != right.remote_rank_map;
-    bool d = *(static_cast< ::MPI_Comm*>(mpi_inter_comm)) != *(static_cast< ::MPI_Comm*>(right.mpi_inter_comm));
-    bool e = size_rank_info != right.size_rank_info;
-    bool f = intercomm_tag != right.intercomm_tag;
-    return a||b||c||d||e||f;
+    mpi_request = static_cast< ::MPI_Request*>(request);
+  }
+  
+  ep_status::ep_status(void* status)
+  {
+    mpi_status = static_cast< ::MPI_Status*>(status);
   }
 
-  ep_communicator::ep_communicator()
-  {
-    comm_list = NULL;
-    message_queue = NULL;
-    intercomm = NULL;
-  }
-
-  MPI_Message::MPI_Message(void* message)
-  {
-    mpi_message = new ::MPI_Message;
-    *(static_cast< ::MPI_Message*>(mpi_message)) = *(static_cast< ::MPI_Message*>(message));
-  }
-
-  MPI_Info::MPI_Info(void* info)
-  {
-    mpi_info = new ::MPI_Info;
-    *(static_cast< ::MPI_Info*>(mpi_info)) = *(static_cast< ::MPI_Info*>(info));
-  }
-  
-  MPI_Info::MPI_Info()
-  {
-    mpi_info = new ::MPI_Info;
-    *(static_cast< ::MPI_Info*>(mpi_info)) = *(static_cast< ::MPI_Info*>(MPI_INFO_NULL.mpi_info));
-  }
-  
-  MPI_Request::MPI_Request(void* request)
-  {
-    mpi_request = new ::MPI_Request;
-    *(static_cast< ::MPI_Request*>(mpi_request)) = *static_cast< ::MPI_Request*>(request);
-  }
+  /*
   
   MPI_Aint::MPI_Aint(void* aint)
@@ -77,4 +39,16 @@
     mpi_aint = new ::MPI_Aint;
     *(static_cast< ::MPI_Aint*>(mpi_aint)) = *(static_cast< ::MPI_Aint*>(aint));
+  }
+
+  MPI_Aint::MPI_Aint(int aint)
+  {
+    mpi_aint = new ::MPI_Aint;
+    *(static_cast< ::MPI_Aint*>(mpi_aint)) = aint;
+  }
+
+  MPI_Aint MPI_Aint::operator=(int a)
+  {
+    mpi_aint = new ::MPI_Aint;
+    *(static_cast< int*>(mpi_aint)) = a; 
   }
   
@@ -85,78 +59,7 @@
   }
 
-  bool ep_communicator::operator == (ep_communicator right)
-  {
-    bool a = size_rank_info == right.size_rank_info;
-    bool b = comm_label == right.comm_label;
-    bool c = intercomm == right.intercomm;
-    return a&&b&&c;
-  }
-
-  bool ep_communicator::operator != (ep_communicator right)
-  {
-    bool a = size_rank_info != right.size_rank_info;
-    bool b = comm_label != right.comm_label;
-    bool c = intercomm != right.intercomm;
-    return a||b||c;
-  }
-
-  MPI_Comm::MPI_Comm()
-  {
-    is_ep = true;
-    is_intercomm = false;
-    my_buffer = NULL;
-    ep_barrier = NULL;
-    rank_map = NULL;
-    ep_comm_ptr = NULL;
-    mem_bridge = NULL;
-    mpi_bridge = NULL;
-    mpi_comm = new ::MPI_Comm;
-  }
-
   
-
-  MPI_Comm::MPI_Comm(void* comm)
-  {
-    is_ep = false;
-    is_intercomm = false;
-    my_buffer = NULL;
-    ep_barrier = NULL;
-    rank_map = NULL;
-    ep_comm_ptr = NULL;
-    mem_bridge = NULL;
-    mpi_bridge = NULL;
-    mpi_comm = new ::MPI_Comm;
-    *(static_cast< ::MPI_Comm*>(mpi_comm)) = *(static_cast< ::MPI_Comm*>(comm));
-  }
-
+*/
   
-
-  bool MPI_Comm::operator == (MPI_Comm right)
-  {
-    bool a = is_ep == right.is_ep;
-    bool b = is_intercomm == right.is_intercomm;
-    bool c = *(static_cast< ::MPI_Comm*>(mpi_comm)) == *(static_cast< ::MPI_Comm*>(right.mpi_comm));
-    bool d = is_ep ? ep_comm_ptr == right.ep_comm_ptr : true;
-    return a&&b&&c&&d;
-  }
-
-  bool MPI_Comm::operator != (MPI_Comm right)
-  {
-    bool a = is_ep != right.is_ep;
-    bool b = is_intercomm != right.is_intercomm;
-    bool c = *(static_cast< ::MPI_Comm*>(mpi_comm)) != *(static_cast< ::MPI_Comm*>(right.mpi_comm));
-    bool d = is_ep ? ep_comm_ptr != right.ep_comm_ptr : true;
-    return a||b||c||d;
-  }
-
-  bool MPI_Request::operator == (MPI_Request right)
-  {
-    bool b = type == right.type;
-    bool c = buf == right.buf;
-    bool d = ep_src == right.ep_src;
-    bool e = ep_tag == right.ep_tag;
-    bool f = ep_datatype == right.ep_datatype;
-    return b&&c&&d&&e&&f;
-  }
 
 
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.hpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.hpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_type.hpp	(revision 1520)
@@ -12,5 +12,4 @@
 #include <numeric>
 #include <bitset>
-//#include <memory.h>
 #include <algorithm>
 #include <assert.h>
@@ -24,228 +23,31 @@
 #endif
 
+#ifdef _Memory_check
+#define memcheck(x) std::cout << x << std::endl
+#else
+#define memcheck(x)
+#endif
+
+
 #define BUFFER_SIZE 10000
 
-//#define NUM_THREADS 12
-
-typedef std::pair< int, int > SIZE_RANK_INFO; // < rank, size>
-
-typedef std::vector< std::pair<int, int> > RANK_MAP;  // at(ep_rank) = <ep_rank_local, mpi_rank>
-
-typedef std::vector<std::pair< std::pair<int, int>, std::pair<int, int> > > INTERCOMM_RANK_MAP;
+#include "ep_status.hpp"
+#include "ep_request.hpp"
+#include "ep_info.hpp"
+#include "ep_message.hpp"
+#include "ep_barrier.hpp"
+#include "ep_comm.hpp"
+#include "ep_intercomm.hpp"
+#include "ep_window.hpp"
 
 
-typedef struct
-{
-  int first;
-  int second;
-  int third;
-} Triple_int;
 
 namespace ep_lib
 {
-  //#define EP_UNDEFINED -32766
 
   class ep_communicator;
   class ep_intercomm;
-  class OMPbarrier;
-  typedef ep_communicator* EP_Comm;
-  class MPI_Comm;
 
 
-  class MPI_Status
-  {
-    public:
-
-      void* ep_datatype;
-      int ep_src;
-      int ep_tag;
-      void* mpi_status;
-  };
-
-  class MPI_Message
-  {
-    public:
-
-      void* mpi_message;
-      int ep_src;
-      int ep_tag;
-      void* mpi_status;
-
-      MPI_Message() {}
-      MPI_Message(void* message);
-  };
-
-  typedef std::list<MPI_Message > Message_list;
-
-
-  class OMPbarrier
-  {
-    private:
-      int nbThreads;          //<The number of threads for this barrier
-      int currentNbThread;    //<The current number of threads waiting
-      bool sense;             //<Direct barrier feedback protection
-      omp_lock_t mutex;       //<To have an atomic int
-
-      OMPbarrier(OMPbarrier&){}
-      OMPbarrier& operator=(OMPbarrier&){return *this;}
-
-    public:
-      /** Constructor with the number of threads */
-      explicit OMPbarrier(const int inNbThreads)
-          : nbThreads(inNbThreads), currentNbThread(0), sense(false) {
-          omp_init_lock( &mutex );
-      }
-
-      /** Destructor, release the omp lock */
-      ~OMPbarrier(){
-          omp_destroy_lock( &mutex );
-      }
-
-      /** Perform a barrier */
-      void wait(){
-          const bool mySense = sense;
-          omp_set_lock( &mutex );
-          const int nbThreadsArrived = (++currentNbThread);
-          omp_unset_lock( &mutex );
-
-          if(nbThreadsArrived == nbThreads) {
-              currentNbThread = 0;
-              sense = !sense;
-              #pragma omp flush
-          }
-          else {
-              volatile const bool* const ptSense = &sense;
-              while( (*ptSense) == mySense){
-              }
-          }
-      }
-
-
-      /** Change the number of threads */
-      void setNbThreads(const int inNbThread){
-          omp_set_lock( &mutex );
-          nbThreads = inNbThread;
-          omp_unset_lock( &mutex );
-      }
-  };
-
-  class ep_intercomm
-  {
-    public:
-
-    void *mpi_inter_comm;
-
-    RANK_MAP *intercomm_rank_map;
-    RANK_MAP *local_rank_map;
-    RANK_MAP *remote_rank_map;
-
-
-    SIZE_RANK_INFO size_rank_info[3];
-
-
-    MPI_Comm *local_comm;
-    int intercomm_tag;
-
-    ep_intercomm();
-    //~ep_intercomm(){delete mpi_inter_comm;}
-    bool operator == (ep_intercomm right);
-    bool operator != (ep_intercomm right);
-    
-
-
-  };
-
-
-  class ep_communicator
-  {
-    public:
-
-    SIZE_RANK_INFO size_rank_info[3]; // 0: ep_rank,     ep_size
-                                      // 1: ep_rank_loc, num_ep
-                                      // 2: mpi_rank,    mpi_size
-
-
-    MPI_Comm *comm_list;
-
-    Message_list *message_queue;
-
-
-    int comm_label;
-
-    ep_intercomm *intercomm;
-
-    ep_communicator();
-    bool operator == (ep_communicator right);
-    bool operator != (ep_communicator right);
-    
-  };
-
-
-  struct BUFFER
-  {
-    void * void_buffer[12];
-  };
-
-
-  class MPI_Comm
-  {
-    public:
-
-    bool is_ep;
-    bool is_intercomm;
-
-    BUFFER     *my_buffer;
-    OMPbarrier *ep_barrier;
-    RANK_MAP   *rank_map;
-    void* mpi_comm;
-    EP_Comm ep_comm_ptr;
-    MPI_Comm *mem_bridge;
-    void* mpi_bridge;
-
-    MPI_Comm();  
-    MPI_Comm(void* comm);
-    //~MPI_Comm(){delete mpi_comm;}
-
-
-    bool operator == (MPI_Comm right);
-    bool operator != (MPI_Comm right);
-    bool is_null();
-
-  };
-
-
-  class MPI_Info
-  {
-    public:
-
-      void* mpi_info;
-
-      MPI_Info();
-      MPI_Info(void* info);
-  };
-
-
-  class MPI_Request
-  {
-    public:
-
-      void* mpi_request;
-
-      int type;	//! type of the non-blocking communication. 1: Isend; 2:Irecv; 3:Imrecv; 4:Issend
-      void* buf;
-
-      int ep_src;
-      int ep_tag;
-      void* ep_datatype;
-
-      MPI_Comm comm;	//! EP communicator related to the communication
-
-      MPI_Request() {}
-      MPI_Request(void* request);
-      bool operator == (MPI_Request right);
-
-  };
-
-  
   class MPI_Aint
   {
@@ -256,5 +58,6 @@
     MPI_Aint() {}
     MPI_Aint(void* aint);
-    //MPI_Aint(int a): mpi_aint(a) {}
+    MPI_Aint(int aint);
+    MPI_Aint operator=(int a);
   };
 
@@ -262,12 +65,13 @@
   {
     public:
-
+  
     void* mpi_fint;
-
+    
     MPI_Fint() {}
     MPI_Fint(void* fint);
-    //MPI_Fint(int f): mpi_fint(f) {}
-    
+                                 
   };
+ 
+  
 
 
@@ -278,9 +82,8 @@
   static std::list<std::pair<std::pair<int, int>, MPI_Comm * > > tag_list;
 
+  static std::list< std::pair<std::pair<int, int> , std::pair<MPI_Comm * , std::pair<int, int> > > > intercomm_list;
+
   static std::map<std::pair<int, int>, MPI_Comm >  fc_comm_map;
 
-//  static std::map<std::pair<int, int>, MPI_Comm >  *fc_comm_map_ptr;
-//  #pragma omp threadprivate(fc_comm_map_ptr)
-//            //    <MPI_Fint,thread_num>   EP_Comm
 
 }
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_wait.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_wait.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_wait.cpp	(revision 1520)
@@ -9,4 +9,5 @@
 #include <mpi.h>
 #include "ep_declaration.hpp"
+#include "ep_mpi.hpp"
 
 using namespace std;
@@ -22,5 +23,5 @@
   int MPI_Wait(MPI_Request *request, MPI_Status *status)
   {
-    if(request->type !=1 && request->type !=2 && request->type !=3) 
+    if((*request)->type !=1 && (*request)->type !=2 && (*request)->type !=3) 
     {
       printf("Error in request type\n");
@@ -29,24 +30,21 @@
     }
 
-    while(request->type == 2) Request_Check();
+    while((*request)->type == 2) Request_Check();
+    
+    ::MPI_Wait(to_mpi_request_ptr(*request), to_mpi_status_ptr(status));
 
+    
+    status->ep_src = (*request)->ep_src;
+    status->ep_tag = (*request)->ep_tag;
+    status->ep_datatype = (*request)->ep_datatype;
+    
+    (*request)->state = 2;
 
-    //::MPI_Request mpi_request = static_cast< ::MPI_Request >(request->mpi_request);
-    ::MPI_Status mpi_status;
-    ::MPI_Wait(static_cast< ::MPI_Request*>(request->mpi_request), &mpi_status);
-
-   
-           
- 
-    // request->mpi_request = mpi_request;
-
-    status->mpi_status = &mpi_status;
-    status->ep_src = request->ep_src;
-    status->ep_tag = request->ep_tag;
-    status->ep_datatype = request->ep_datatype;
+    memcheck("delete "<< (*request)->mpi_request << " : in ep_lib::MPI_Wait, delete (*request)->mpi_request");
+    delete (*request)->mpi_request;
+    delete *request;
     
 
-
-    return MPI_SUCCESS;
+    return Request_Check();
 
   }   /*end of mpi_wait*/
@@ -69,5 +67,5 @@
       for(int i=0; i<count; i++)
       {
-        if(array_of_requests[i].type !=1 && array_of_requests[i].type !=2 && array_of_requests[i].type !=3) 
+        if(array_of_requests[i]->type !=1 && array_of_requests[i]->type !=2 && array_of_requests[i]->type !=3) 
         {
           printf("Error in request type\n");
@@ -76,10 +74,9 @@
         }
         
-        if(array_of_requests[i].type == 2) Request_Check(); 
-        if(array_of_requests[i].type != 2 && finished.at(i) == 0) 
+        if(array_of_requests[i]->type == 2) Request_Check(); 
+        if(array_of_requests[i]->type != 2 && finished.at(i) == 0) 
         {
           finished.at(i) = 1;
-          //mpi_request[i] = static_cast< ::MPI_Request >(array_of_requests[i].mpi_request);
-          mpi_request[i] = *static_cast< ::MPI_Request*>(array_of_requests[i].mpi_request);
+          mpi_request[i] = *static_cast< ::MPI_Request*>(array_of_requests[i]->mpi_request);
         }
       }    
@@ -91,7 +88,13 @@
     {
       array_of_statuses[i].mpi_status = &mpi_status[i];
-      array_of_statuses[i].ep_src = array_of_requests[i].ep_src;
-      array_of_statuses[i].ep_tag = array_of_requests[i].ep_tag;
-      array_of_statuses[i].ep_datatype = array_of_requests[i].ep_datatype;
+      array_of_statuses[i].ep_src = array_of_requests[i]->ep_src;
+      array_of_statuses[i].ep_tag = array_of_requests[i]->ep_tag;
+      array_of_statuses[i].ep_datatype = array_of_requests[i]->ep_datatype;
+      
+      array_of_requests[i]->state = 2;
+      
+      memcheck("delete "<< array_of_requests[i]->mpi_request <<" : in ep_lib::MPI_Waitall, array_of_requests["<<i<<"]->mpi_request");
+      delete array_of_requests[i]->mpi_request;
+      delete array_of_requests[i];
     }
 
@@ -99,6 +102,5 @@
     delete[] mpi_status;
     
-    
-    return MPI_SUCCESS;
+    return Request_Check();
   }  /* end of mpi_waitall*/
 
